//Russian version RTC

#include <ESP8266WiFi.h>
//#include "Timer.h"
#include <EEPROM.h>
#include <Time.h>

//char SSID[] = "ASUS-YER";  //  your network SSID (name)
char SSID[] = "YOTA_YER";  //  your network SSID (name)
char PASSWORD[] = "********";       // your network password

char buffer[20];
char TimeZone=3;
char NextionCMD;
boolean stringComplete=false;
String inputString = "";         // a string to hold incoming data
String inputString1 = "";

#define HOST_NAME   "api.wunderground.com"
#define HOST_PORT   (80)


//EEPROM addresses
#define TZaddr		0		//0	TimeZone
#define SSIDaddr	1		//1-20
#define PASSaddr	21		//21-40
#define Stateaddr	41		//41-60
#define Cityaddr	61		//61-80

const int json_buffer=400;
int num_elements=6, i;
const char* forecast[]       ={"\"celsius\":","\"celsius\":","\"icon\":","\"avehumidity\":","\"celsius\":","\"celsius\":","\"icon\":","\"avehumidity\":"};
const char* forecast_rename[]={"\"celsius_h_1\":","\"celsius_l_1\":","\"icon_1\":","\"avehumidity_1\":","\"celsius_h_2\":","\"celsius_l_2\":","\"icon_2\":","\"avehumidity_2\":"}; //rename for same data name.
const char* conds[]={"Date","\"weather\":","\"temp_c\":","\"relative_humidity\":","\"wind_dir\":","\"wind_kph\":"};
const char* Months[]={"Zer","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

WiFiClient client;

String rain="Drizzle, Rain, Snow, Snow Grains, Ice Crystals, Ice Pellets, Hail, Low Drifting Snow,\
			Blowing Snow, Rain Mist,     Rain Showers, Snow Showers, Snow Blowing Snow Mist, Ice Pellet Showers, Hail Showers, Small Hail Showers,       Freezing Drizzle, Freezing Rain, Small Hail, chanceflurries,chancerain,       chancesleet,          chancesnow,     sleet,       rain, snow";
//String rain= ", , ,  ,  ,  , , ,\
			 ,  , ,       ,      ,             ,  ,      , ,          ,  , ,         ,   ,  ,  , , ";

String thunde="Thunderstorm, Thunderstorms and Rain, Thunderstorms and Snow, Thunderstorms and Ice Pellets,\
				 Thunderstorms with Hail, Thunderstorms with Small Hail,chancetstorms, tstorms";
//String thunde  =",  ,  ,   ,\
				  ,   ,  , ";

String sunny="Clear, Unknown Precipitation, Unknown, sunny, unknown";

//String sunny  = ", , , , "; 

String cloudy ="Overcast ,Mist, Fog, FogPatches, Smoke, VolcanicAsh, WidespreadDust,Sand, Haze, Spray, DustWhirls, \
			   Sandstorm, LowDrifting WidespreadDust, LowDriftingSand, BlowingWidespreadDust, BlowingSand, FreezingFog, \
			   PatchesofFog, ShallowFog, PartlyCloudy, MostlyCloudy, ScatteredClouds, Squalls, FunnelCloud, cloudy, flurries, \
			   fog, hazy, mostlycloudy, mostlysunny, partlycloudy, partlysunny";

int num_elements_fr = 8; 
String city="Moscow";
String state="Russia";
String stateCity="";
String json_current="";
String json_forecast="";
bool flag=false;
//Timer t;

String WeekDay, Hour, Minute, Second;

typedef struct _current_data {
    String week_time;
    String tom1;
    String tom2;
    String month;
    String Addr;
    String temp;
    String weather;
    String hum;
    String wind;
    String wind_dir;
}current_datas;
typedef struct _forecast_data {
    String temp_h_tom;
    String temp_l_tom;
    String temp_tom;
    String weather_tom;
    String hum_tom;
    String temp_h_tom2;
    String temp_l_tom2;
    String temp_tom2;
    String weather_tom2;
    String hum_tom2;
}forecast_datas;

String weeks="Monday,Tuesday,Wednesday,Thursday,Friday,Saturday,Sunday,";
//String weeks=", , , , , , ";
current_datas current_data;
forecast_datas forecast_data;

bool getCurrentConditions(void){
       String cmd= "GET /api/825673f1354b4021/conditions/q/"+state+"/"+city+".json"+" HTTP/1.1\r\nHost: api.wunderground.com\r\n\r\n";

      Serial1.println(cmd.c_str());
	   client.print(cmd.c_str());

    unsigned int i=0;
    unsigned int timeout_current=0;
    json_current = "{" ;

	while(!client.available());
    for( int j=0; j<num_elements;j++ ){
		while (!client.find(conds[j])){
         timeout_current++;
         Serial1.println(timeout_current);
         if(timeout_current==10){
           Serial1.println("it is error");
           timeout_current=0;
           return false;
         }
       }
       String str1 = conds[j];
       for(int l=0;l<(str1.length());l++){
         json_current += str1[l];
       }
       while(i<60000){
		   if(client.available()){
           char c=client.read();

           if(str1=="Date"){
                if(c== 0x0D ) break;
           }
           else{ 
             if(c==','|| c == 0x0d) break;
             if(c == 0x20) continue;
           }
           json_current +=c;
           i=0;
         }
         i++;
       }
       if(j==num_elements-1){
         json_current+='}';
       }
       else{
         json_current+=',';
       }
    }

      Serial1.println("json_current[j]");
    for(int j=0;j<json_current.length();j++){
      Serial1.print(json_current[j]);
    }
	Serial1.println();	
    Serial1.println("=============================\r\n");

    // Close socket and wait for disconnect from WiFi
    client.stop();

	if(client.status() == 0) Serial1.println("Client_Stopped OK\r\n");
	else Serial1.println("Client Stop ERROR");

    return true;
}

bool connectTCP(void){
    uint8_t create_tcp_count=0;
    uint8_t create_tcp_flag=0;

    for(create_tcp_count=0;create_tcp_count<10;create_tcp_count++){
        if (client.connect(HOST_NAME, HOST_PORT)) {
            Serial1.println("create tcp ok\r\n");
			Serial1.print("Client_Status");
			Serial1.println(client.status(),DEC);

            create_tcp_count=10;
            create_tcp_flag=1;
            return true;
        }
        else{
            Serial1.print("create tcp failure,try  again");
        }
    }

    if ((!create_tcp_flag)&&create_tcp_count==10){
        if (joinApDisableMux()){
            connectTCP();
        }
    }
    return true;
}

bool getForecast(void){
    connectTCP();
    String cmd= "GET /api/825673f1354b4021/forecast/q/"+state+"/"+city+".json"+" HTTP/1.1\r\nHost: api.wunderground.com\r\n\r\n";

    Serial1.println(cmd.c_str());
	client.print(cmd.c_str());
	delay(10);

while(!client.available());
    unsigned int i=0;
    unsigned int timeout_forecast=0;
    json_forecast="{";

//wait for "simpleforecast": { phrase
	while(!client.find("\"simpleforecast\": {")){
      timeout_forecast++;
      Serial1.println(timeout_forecast);
      if(timeout_forecast==10){
        Serial1.println("it is error");
        timeout_forecast=0;
        return false;
      }
    }

//wait for "minhumidity": phrase
	  while(!client.find("\"minhumidity\":")){
      timeout_forecast++;
      Serial1.println(timeout_forecast);
      if(timeout_forecast==10){
        Serial1.println("it is error");
        timeout_forecast=0;
        return false;
      }
    }
   
    for(int j=0;j<num_elements_fr;j++){

      while(!client.find(forecast[j])){}
      String str1=forecast_rename[j];
      for(int l=0;l<(str1.length());l++){
        json_forecast += str1[l];
      }
      while(i<60000){
		  if(client.available()){
			char c=client.read();
          if (c==',' || c == '}') {break;}
          if(c == 0x09 || c == 0x20 || c == 0x0A ) {
            continue;
          }
          json_forecast += c;
          i=0;
        }
        i++;
      }
      if(j==num_elements_fr-1){
        json_forecast += '}';
      }
      else{
        json_forecast += ',';
      }
    }
    
	 Serial1.println("json_forecast[j]");
     for(int j=0;j<json_forecast.length();j++){
      Serial1.print(json_forecast[j]);
    }
      Serial1.println("\r\n=========================\r\n");
   return true;
}

void enterStateCity(void)
{
      stateCity="";
	  flag=false;

	delay(100);	
  sendToLCD(1,"t1", "enter State-City");

  while (Serial.available()==0);
  if(Serial.available())getNextion();

  	if (stringComplete) stringComplete = false;
	
	stateCity = inputString;

	  sendToLCD(1, "t1", stateCity);
	  delay(1000);

  sendToLCD(1,"t1", "enter TimeZone");

  while (Serial.available()==0);
  if(Serial.available())getNextion();

  	if (stringComplete) stringComplete = false;
	
	TimeZone = (char)inputString.toInt();
	EEPROM.write (0, TimeZone);

	  sendToLCD(1, "t1", inputString);
	  delay(1000);

	  sendToLCD(4,"", "0");

    Serial1.println("i am here");
    flag=false;
    Serial1.println(stateCity.c_str());
    state=stateCity.substring(0,stateCity.indexOf("-"));
    city=stateCity.substring(stateCity.indexOf("-")+1,stateCity.length());
    Serial1.println(state.c_str());
    Serial1.println(city.c_str());
	EEPROMwrite(Stateaddr, state);
	EEPROMwrite(Cityaddr, city);

    setWeatherData();
}

bool getTimeDate(String &data)
{
   Serial1.println("getTimeDate");
  int32_t index1=data.indexOf("Date:");
  int32_t index2=data.indexOf(",");
  if (index1 != -1 && index2 != -1) {
        index1 += 5;
        current_data.week_time = data.substring(index1+1, index2);
        current_data.week_time = recvFindTimeData(weeks,current_data.week_time,",");
        if(current_data.week_time.indexOf("Sat")!=-1){   
            current_data.tom1="Sunday";
            current_data.tom2="Monday";
        }
        else if(current_data.week_time.indexOf("Sun")!=-1){
            current_data.tom1="Monday";
            current_data.tom2="Tuesday";
        }
        else {
          current_data.tom1 = recvFindWeatherData(weeks,(current_data.week_time+","),",");
          current_data.tom2 = recvFindWeatherData(weeks,(current_data.tom1+","),",");
        }
      }
   int32_t index3 = data.indexOf(" ",index2+10);
   if(index3 != -1){
       current_data.month = data.substring(index2+2,index3);
 //      current_data.week_time += data.substring(index3,index3+6);
       current_data.week_time += data.substring(index3,index3+9);

   
   Serial1.printf("Index1, 2, 3\n\r");
   Serial1.printf("%d %d %d\n\r",index1,index2,index3);




       return true;
     }

    data = "ERROR";
    return false;  
}

String recvFindTimeData(String &data_tmp, String begin, String end)
{
    String data;
    int32_t index1 = data_tmp.indexOf(begin);
    int32_t index2 = data_tmp.indexOf(end,index1+1);
    if (index1 != -1 && index2 != -1) {
        data = data_tmp.substring(index1, index2);
        return data;
        }
    data = "ERROR";
    return data;
}

String recvFindWeatherData(String &data_tmp, String begin, String end)
{
    String data;
    int32_t index1 = data_tmp.indexOf(begin);
    int32_t index2 = data_tmp.indexOf(end,index1+begin.length());
    if (index1 != -1 && index2 != -1) {
        index1 += begin.length();
        data = data_tmp.substring(index1, index2);
        return data;
        }
    data = "ERROR";
    return data;
}

void getWeatherData(void)
{
	int vMonth;
	Serial1.println("getWeatherData");
	Serial1.print("CurrentData= ");
	Serial1.println(current_data.month.c_str());
    if(getTimeDate(json_current)){
        Serial1.println(current_data.week_time.c_str());

		String Year    = current_data.month.substring(7,11);
		String Month   = current_data.month.substring(current_data.month.indexOf(" ")+1, current_data.month.indexOf(" ")+4);
		String Day     = current_data.month.substring(0,current_data.month.indexOf(" "));
			   WeekDay = current_data.week_time.substring(0,current_data.week_time.indexOf(" "));
		String Time    = current_data.week_time.substring(current_data.week_time.indexOf(" ")+1,current_data.week_time.length());
		       Hour    = Time.substring(0,Time.indexOf(":"));
		       Minute  = Time.substring(Time.indexOf(":")+1,Time.length()-3);
		       Second  = Time.substring(Time.indexOf(":")+4,Time.length());

		Serial1.println("Year="+Year);		
		Serial1.println("Month="+Month);
		Serial1.println("Day="+Day);
		Serial1.println("WeekDay="+WeekDay); 		
		Serial1.println("Time="+Time);       
		Serial1.println("Hour="+Hour);		
		Serial1.println("Minute="+Minute);
        Serial1.println("Second="+Second);


		int vYear = Year.toInt();
		for(vMonth=1; vMonth<13;vMonth++){
			if ((String)Months[vMonth] == Month) break;
		}
		int vDay    = Day.toInt();
		int vHour   = Hour.toInt()+TimeZone;
		int vMinute = Minute.toInt();
		int vSecond = Second.toInt();



		  
        Serial1.printf("vMonth=%d\n\r", vMonth);

		sprintf(buffer,"%d",vHour);
		Hour = (String)(buffer);

		setTime(vHour,vMinute,vSecond,vDay,vMonth,vYear); 

        Serial1.printf("Timestatus=%d\n\r", timeStatus());

		current_data.week_time = WeekDay+" "+Hour+":"+ Minute + ":" + Second;

        Serial1.println(current_data.week_time.c_str());
        Serial1.println(current_data.month.c_str());
        Serial1.println(current_data.tom1.c_str());
        Serial1.println(current_data.tom2.c_str());
    }
    current_data.weather=recvFindWeatherData(json_current,"weather\":\"", "\",");
    Serial1.println(current_data.weather.c_str());
    
    current_data.temp=recvFindWeatherData(json_current,"temp_c\":", ",\"");
    Serial1.println(current_data.temp.c_str());
    
    current_data.hum=recvFindWeatherData(json_current,"humidity\":\"", "\",");
    Serial1.println(current_data.hum.c_str());
    
    current_data.wind_dir=recvFindWeatherData(json_current,"wind_dir\":\"", "\",");
    Serial1.println(current_data.wind_dir.c_str());
    
    current_data.wind=current_data.wind_dir+" "+ recvFindWeatherData(json_current,"wind_kph\":", "}")+"KM/h";
    Serial1.println(current_data.wind.c_str());
    
    forecast_data.temp_h_tom=recvFindWeatherData(json_forecast,"\"celsius_h_1\":\"" , "\",");
    Serial1.println(forecast_data.temp_h_tom.c_str());
    
    forecast_data.temp_l_tom=recvFindWeatherData(json_forecast,"\"celsius_l_1\":\"" , "\",");
    Serial1.println(forecast_data.temp_l_tom.c_str());
    
    forecast_data.temp_tom=forecast_data.temp_h_tom+"C-"+forecast_data.temp_l_tom+"C";
    Serial1.println(forecast_data.temp_tom.c_str());
        
    forecast_data.weather_tom=recvFindWeatherData(json_forecast,"\"icon_1\":\"" , "\",");
    Serial1.println(forecast_data.weather_tom.c_str());
        
    forecast_data.hum_tom=recvFindWeatherData(json_forecast,"\"avehumidity_1\":" , ",\"");
    Serial1.println(forecast_data.hum_tom.c_str());
    
    forecast_data.temp_h_tom2=recvFindWeatherData(json_forecast,"\"celsius_h_2\":\"" , "\",");
    Serial1.println(forecast_data.temp_h_tom2.c_str());
    
    forecast_data.temp_l_tom2=recvFindWeatherData(json_forecast,"\"celsius_l_2\":\"" , "\",");
    Serial1.println(forecast_data.temp_l_tom2.c_str());
    
    forecast_data.temp_tom2=forecast_data.temp_h_tom2+"C-"+forecast_data.temp_l_tom2+"C";
    Serial1.println(forecast_data.temp_tom2.c_str());
    
    forecast_data.weather_tom2=recvFindWeatherData(json_forecast,"\"icon_2\":\"" , "\",");
    Serial1.println(forecast_data.weather_tom2.c_str());
        
    forecast_data.hum_tom2=recvFindWeatherData(json_forecast,"\"avehumidity_2\":" , "}");
    Serial1.println(forecast_data.hum_tom2.c_str()); 

	Serial1.println("END_getWeatherData");
}

/*type 1- text, 2 - numerical data for progbar,  3- picture,  4 - page "", p, index - screen element, cmd - data */
void sendToLCD(uint8_t type,String index, String cmd)
{
    if (type == 1 ){
        Serial.print(index);
        Serial.print(".txt=");
        Serial.print("\"");
        Serial.print(cmd);
        Serial.print("\"");
    }
    else if (type == 2){
        Serial.print(index);
        Serial.print(".val=");
        Serial.print(cmd);
    }
    else if (type == 3){
        Serial.print(index);
        Serial.print(".picc="); 
 //       Serial.print(".pic="); 
        Serial.print(cmd);
    }
    else if (type ==4 ){
        Serial.print("page ");
        Serial.print(cmd);
    }
    
    else if (type ==5 ){
        Serial.print(cmd);
    }

     Serial.write(0xff);
     Serial.write(0xff);
     Serial.write(0xff);

	 delay(100);
  while(Serial.available()){
	  Serial.read();
	}
}

void sendWeatherData(void)
{
    sendToLCD(1,"t2"," ");
    sendToLCD(1,"t0",city);
    sendToLCD(1,"t2",current_data.month);
    sendToLCD(1,"t1",current_data.week_time);
    sendToLCD(1,"t3",current_data.temp);
    sendToLCD(1,"t7",current_data.wind);
    sendToLCD(1,"t8",current_data.weather);
    sendToLCD(1,"t10",current_data.hum);
    sendToLCD(1,"t11",current_data.tom1);
    sendToLCD(1,"t13",forecast_data.hum_tom);
    sendToLCD(1,"t14",forecast_data.temp_tom);
    
    sendToLCD(1,"t15",current_data.tom2);
    sendToLCD(1,"t18",forecast_data.hum_tom2);
    sendToLCD(1,"t16",forecast_data.temp_tom2);   
    
    if(rain.indexOf(current_data.weather)!=-1){
        sendToLCD(3,"q0","11");
     //   Serial1.println("it is rain");
    }
    else if(thunde.indexOf(current_data.weather)!=-1){
        sendToLCD(3,"q0","12");
   //     Serial1.println("it is thunde");
    }
   else if(cloudy.indexOf(current_data.weather)!=-1){
       sendToLCD(3,"q0","14");
  //     Serial1.println("it is cloudy");
   }
   else{
       sendToLCD(3,"q0","10");
   //    Serial1.println("it is sunny");
   }
   
   if(rain.indexOf(forecast_data.weather_tom)!=-1){
        sendToLCD(3,"q1","5");
    }
    else if(thunde.indexOf(forecast_data.weather_tom)!=-1){
        sendToLCD(3,"q1","7");
    }
   else if(cloudy.indexOf(forecast_data.weather_tom)!=-1){
       sendToLCD(3,"q1","9");
   }
   else{
       sendToLCD(3,"q1","3");
   }
   
   if(rain.indexOf(forecast_data.weather_tom2)!=-1){
        sendToLCD(3,"q2","4");
    }
    else if(thunde.indexOf(forecast_data.weather_tom2)!=-1){
        sendToLCD(3,"q2","6");
    }
   else if(cloudy.indexOf(forecast_data.weather_tom2)!=-1){
       sendToLCD(3,"q2","8");
   }
   else{
       sendToLCD(3,"q2","2");
   }

}

void setWeatherData(void)
{ 

	Serial1.println("setWeatherData");
  //  sendToLCD(2,"j0","100");
  //  sendToLCD(4,"","0"); 
  bool input_flag = true;
  sendToLCD(2,"j0","30");
  if(!getForecast()){
    Serial1.println("Get Forecast data false");
    input_flag=false;
 //   sendToLCD(4,"","1");
  }  
  else{
 //   sendToLCD(2,"j0","50");
    Serial1.println("Get Forecast data ok");
 ////   sendToLCD(4,"","1");
  }
  if(!getCurrentConditions()){
    Serial1.println("Get CurrentConditions data false");
    input_flag=false;
  }
   else{
    sendToLCD(2,"j0","80");
    Serial1.println("Get CurrentConditions data ok");
  } 
   if(!input_flag){
       sendToLCD(2,"j0","100");
//       sendToLCD(4,"","1");
       sendToLCD(4,"","2");
   }
   else{
      getWeatherData();
       sendToLCD(2,"j0","100");
       sendToLCD(4,"","0");
       sendWeatherData();
   }
}

bool joinApDisableMux(void){
  bool join_flag=0;
  int attempt = 0;

  Serial1.println();
  Serial1.println();
  Serial1.print("Connecting to ");
  Serial1.println(SSID);

	WiFi.begin(SSID, PASSWORD);
	while (WiFi.status() != WL_CONNECTED) {
		delay(500);
		Serial1.print(".");
		attempt++;
		if(attempt > 20){
			sendToLCD(1,"t1","Join AP Fail!");
		return false;
		}
		}

    Serial1.print("Join AP success\r\n");
	sendToLCD(1,"t1","Join AP success");
    join_flag=1;

    return true;


}

void setup(void)
{

    Serial.begin(115200);
    Serial1.begin(115200);
	Serial1.setDebugOutput(true);

	EEPROM.begin(96);
	delay(100);

	uint8 i = EEPROM.read(0);
	Serial1.println("");
	sprintf(buffer,"\n\rTime_Zone=%d\n\r",i);
	Serial1.println(buffer);
	if ((i!=0)&&(i!=0xFF)) TimeZone = i;

	String tmp = EEPROMread(SSIDaddr);
	Serial1.println("SSID="+tmp);
	if((tmp[0]!=0)&&(tmp[0]!=0xFF)){for (int i=0; i<sizeof(tmp);i++){SSID[i] = tmp[i];	}}
    tmp = EEPROMread(PASSaddr);
	Serial1.println("PASS="+tmp);
	if((tmp[0]!=0)&&(tmp[0]!=0xFF)){for (int i=0; i<sizeof(tmp);i++){PASSWORD[i] = tmp[i];	}}
    tmp = EEPROMread(Stateaddr);
	Serial1.println("State="+tmp);
	if((tmp[0]!=0)&&(tmp[0]!=0xFF)) state = tmp;
	else enterStateCity();
    tmp = EEPROMread(Cityaddr);
	Serial1.println("City="+tmp);
	if((tmp[0]!=0)&&(tmp[0]!=0xFF)) city = tmp;

	sendToLCD(5, "1", "code _c");
	sendToLCD(4,"", "0");
    sendToLCD(1,"t1","");

   if(joinApDisableMux()){
        Serial1.print("setup end\r\n");
    }
   else APsetup();

    setWeatherData();
 //   t.every(600000,setWeatherData);  
}

void loop(void)
{
	if(Serial.available()) getNextion();
	if(stringComplete) parseCMD();

//	enterStateCity();
//    t.update();
	delay(1000);
	refreshTime();
}

void APsetup(void){

  sendToLCD(4,"", "2");
  sendToLCD(1,"t1", "Enter SSID");

  while (Serial.available()==0);
  if(Serial.available())getNextion();

  	if (stringComplete) {
	sendToLCD(1,"t1", inputString);
	stringComplete = false;
	}
	delay(1000);

	Serial1.println("SSID="+inputString);

	for (int i=0; i<sizeof(inputString);i++){	
	SSID[i] = inputString[i];
	}

	EEPROMwrite(SSIDaddr,inputString); 

 sendToLCD(1,"t1", "Enter Password");
  while (Serial.available()==0);
  if(Serial.available())getNextion();

  if (stringComplete) {
	sendToLCD(1,"t1", inputString);
	stringComplete = false;
	}
	delay(1000);

	Serial1.println("Password="+inputString);

	for (int i=0; i<sizeof(inputString);i++){
	PASSWORD[i] = inputString[i];
	}
	EEPROMwrite(PASSaddr,inputString);
}



void parseCMD(void){
	stringComplete = false;
	if (NextionCMD==0x65){
		if(inputString[1]==0x01) APsetup();
		if(inputString[1]==0x02) enterStateCity();
	}
}

void getNextion(void){
    inputString = "";
	stringComplete = false;
	Serial1.println("Entering Nextion");
	while(1) {
//		delayMicroseconds(150);
		delay(1);

		if(!stringComplete){
			NextionCMD=Serial.read();
			stringComplete = true;
			}
		uint8_t inChar = Serial.read();
		if(inChar==255)break;
		inputString += (char)inChar;
	}
}

  
void EEPROMwrite(char addr, String data){
	int i;
	for(i=0; i <= data.length();i++){
	EEPROM.write(addr+i, data[i]);
	}
	EEPROM.write(addr+i+1, 0);
	EEPROM.commit();
}

String EEPROMread(char addr){
	int i=0;
	String data="";
	char c;
	while(1){
	c = EEPROM.read(addr+i);
//	Serial1.print("EEPROMread_char=");
//	Serial1.println(c);
	if(c == 0)break;
	data += c;
	i++;
	} 
//	Serial1.println("");
//	Serial1.println("data="+data);
	return data;
}

void refreshTime(void){

	sprintf(buffer,"%02d",hour());
	Hour = (String)(buffer);
	sprintf(buffer,"%02d",minute());
	Minute = (String)(buffer);
	sprintf(buffer,"%02d",second());
	Second = (String)(buffer);

	if((minute()==0)&&(second()==0)) setWeatherData();

	current_data.week_time = WeekDay+" "+Hour+":"+ Minute + ":" + Second;
	sendToLCD(1,"t1",current_data.week_time);
}